define("icywildsComponentsTensionPort", ["componentmodelComponentApi", "clientkernelEventbusApi"],
    function(componentmodelComponentApi, clientkernelEventbusApi) {
        "use strict";

        function $iterator(o) {
            if (o instanceof Array) return function() {
                return {
                    cur: 0,
                    arr: o,
                    hasNext: function() {
                        return this.cur < this.arr.length;
                    },
                    next: function() {
                        return this.arr[this.cur++];
                    }
                };
            };
            return typeof(o.iterator) == 'function' ? $bind(o, o.iterator) : o.iterator;
        };;
        var $fid = 0;

        function $bind(o, m) {
            if (m == null) return null;
            if (m.__id__ == null) m.__id__ = $fid++;
            var f;
            if (o.hx__closures__ == null) o.hx__closures__ = {};
            else f = o.hx__closures__[m.__id__];
            if (f == null) {
                f = function() {
                    return f.method.apply(f.scope, arguments);
                };
                f.scope = o;
                f.method = m;
                o.hx__closures__[m.__id__] = f;
            }
            return f;
        };
        var $_;
        var $estr = function() {
            return _hcmn_.js_Boot.__string_rec(this, '');
        };
        if (typeof haxe == 'undefined') {
            var haxe = {};
        };

        haxe.IMap = function() {}
        haxe.IMap.prototype = {

        };
        if (typeof icywildsComponentsTensionPort == 'undefined') {
            var icywildsComponentsTensionPort = {};
        };

        icywildsComponentsTensionPort.ITensionImplementationPort = function() {}
        icywildsComponentsTensionPort.ITensionImplementationPort.prototype = {

            getShow: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };

        icywildsComponentsTensionPort.ITensionPort = function() {}
        icywildsComponentsTensionPort.ITensionPort.prototype = {

            getShow: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };
        icywildsComponentsTensionPort.TensionDeclaration = function() {};
        icywildsComponentsTensionPort.TensionDeclaration = ck_implements(icywildsComponentsTensionPort.TensionDeclaration, componentmodelComponentApi.IComponentDeclaration);
        icywildsComponentsTensionPort.TensionDeclaration.__interfaces__ = [componentmodelComponentApi.IComponentDeclaration];
        icywildsComponentsTensionPort.TensionDeclaration.__name__ = ["icywildsComponentsTensionPort", "TensionDeclaration"];
        icywildsComponentsTensionPort.TensionDeclaration.prototype.getChildComponents = function() {
            return null;
        };
        icywildsComponentsTensionPort.TensionDeclaration.prototype.getReferredComponents = function() {
            return null;
        };
        icywildsComponentsTensionPort.TensionDeclaration.prototype.getImplementedPorts = function() {
            return [icywildsComponentsTensionPort.ITensionImplementationPort];
        };
        icywildsComponentsTensionPort.TensionDeclaration.prototype.getUsedPorts = function() {
            return [icywildsComponentsTensionPort.ITensionPort];
        };
        icywildsComponentsTensionPort.TensionDeclaration.prototype.__class__ = icywildsComponentsTensionPort.TensionDeclaration;
        icywildsComponentsTensionPort.TensionPort = function(bus) {
            this.show = new clientkernelEventbusApi.Topic("tension:show");
            this.show.connect(bus);
        };
        icywildsComponentsTensionPort.TensionPort = ck_implements(icywildsComponentsTensionPort.TensionPort, icywildsComponentsTensionPort.ITensionPort);
        icywildsComponentsTensionPort.TensionPort = ck_implements(icywildsComponentsTensionPort.TensionPort, icywildsComponentsTensionPort.ITensionImplementationPort);
        icywildsComponentsTensionPort.TensionPort.__interfaces__ = [icywildsComponentsTensionPort.ITensionPort, icywildsComponentsTensionPort.ITensionImplementationPort];
        icywildsComponentsTensionPort.TensionPort.__name__ = ["icywildsComponentsTensionPort", "TensionPort"];
        icywildsComponentsTensionPort.TensionPort.prototype.show = null;
        icywildsComponentsTensionPort.TensionPort.prototype.getShow = function() {
            return this.show;
        };
        icywildsComponentsTensionPort.TensionPort.prototype.__class__ = icywildsComponentsTensionPort.TensionPort;
        icywildsComponentsTensionPort.TensionPortFactory = function() {};
        icywildsComponentsTensionPort.TensionPortFactory = ck_implements(icywildsComponentsTensionPort.TensionPortFactory, componentmodelComponentApi.IPortFactory);
        icywildsComponentsTensionPort.TensionPortFactory.__interfaces__ = [componentmodelComponentApi.IPortFactory];
        icywildsComponentsTensionPort.TensionPortFactory.__name__ = ["icywildsComponentsTensionPort", "TensionPortFactory"];
        icywildsComponentsTensionPort.TensionPortFactory.prototype.provide = function(channel) {
            return new icywildsComponentsTensionPort.TensionPort(channel);
        };
        icywildsComponentsTensionPort.TensionPortFactory.prototype["use"] = function(channel) {
            return new icywildsComponentsTensionPort.TensionPort(channel);
        };
        icywildsComponentsTensionPort.TensionPortFactory.prototype.__class__ = icywildsComponentsTensionPort.TensionPortFactory;
        icywildsComponentsTensionPort.ShowTensionPayload = function(data, reelId, stopSpin, spinStopped) {
            this.data = data;
            this.stopSpin = stopSpin;
            this.spinStopped = spinStopped;
            this.reelId = reelId;
        };
        icywildsComponentsTensionPort.ShowTensionPayload.__name__ = ["icywildsComponentsTensionPort", "ShowTensionPayload"];
        icywildsComponentsTensionPort.ShowTensionPayload.prototype.data = null;
        icywildsComponentsTensionPort.ShowTensionPayload.prototype.reelId = null;
        icywildsComponentsTensionPort.ShowTensionPayload.prototype.stopSpin = null;
        icywildsComponentsTensionPort.ShowTensionPayload.prototype.spinStopped = null;
        icywildsComponentsTensionPort.ShowTensionPayload.prototype.__class__ = icywildsComponentsTensionPort.ShowTensionPayload;
        return {
            exports: icywildsComponentsTensionPort
        };
    });
//# sourceURL=icyWildsTensionPort.js